/**
 * Autogenerated by Thrift Compiler (1.0.0-dev)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package jayeson.vodds.service.cms.thrift;

import org.apache.thrift.scheme.IScheme;
import org.apache.thrift.scheme.SchemeFactory;
import org.apache.thrift.scheme.StandardScheme;

import org.apache.thrift.scheme.TupleScheme;
import org.apache.thrift.protocol.TTupleProtocol;
import org.apache.thrift.protocol.TProtocolException;
import org.apache.thrift.EncodingUtils;
import org.apache.thrift.TException;
import org.apache.thrift.async.AsyncMethodCallback;
import org.apache.thrift.server.AbstractNonblockingServer.*;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.nio.ByteBuffer;
import java.util.Arrays;
import javax.annotation.Generated;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings({"cast", "rawtypes", "serial", "unchecked"})
@Generated(value = "Autogenerated by Thrift Compiler (1.0.0-dev)", date = "2022-4-26")
public class ThriftGameCreditRequestInfo implements org.apache.thrift.TBase<ThriftGameCreditRequestInfo, ThriftGameCreditRequestInfo._Fields>, java.io.Serializable, Cloneable, Comparable<ThriftGameCreditRequestInfo> {
  private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("ThriftGameCreditRequestInfo");

  private static final org.apache.thrift.protocol.TField T_TYPE_FIELD_DESC = new org.apache.thrift.protocol.TField("tType", org.apache.thrift.protocol.TType.I32, (short)1);
  private static final org.apache.thrift.protocol.TField USER_ID_FIELD_DESC = new org.apache.thrift.protocol.TField("userId", org.apache.thrift.protocol.TType.I64, (short)2);
  private static final org.apache.thrift.protocol.TField AMOUNT_FIELD_DESC = new org.apache.thrift.protocol.TField("amount", org.apache.thrift.protocol.TType.DOUBLE, (short)3);
  private static final org.apache.thrift.protocol.TField GAME_DETAIL_ID_FIELD_DESC = new org.apache.thrift.protocol.TField("gameDetailId", org.apache.thrift.protocol.TType.I64, (short)4);

  private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
  static {
    schemes.put(StandardScheme.class, new ThriftGameCreditRequestInfoStandardSchemeFactory());
    schemes.put(TupleScheme.class, new ThriftGameCreditRequestInfoTupleSchemeFactory());
  }

  /**
   * 
   * @see ThriftTransactionType
   */
  public ThriftTransactionType tType; // required
  public long userId; // required
  public double amount; // required
  public long gameDetailId; // required

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements org.apache.thrift.TFieldIdEnum {
    /**
     * 
     * @see ThriftTransactionType
     */
    T_TYPE((short)1, "tType"),
    USER_ID((short)2, "userId"),
    AMOUNT((short)3, "amount"),
    GAME_DETAIL_ID((short)4, "gameDetailId");

    private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

    static {
      for (_Fields field : EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // T_TYPE
          return T_TYPE;
        case 2: // USER_ID
          return USER_ID;
        case 3: // AMOUNT
          return AMOUNT;
        case 4: // GAME_DETAIL_ID
          return GAME_DETAIL_ID;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    public static _Fields findByName(String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final String _fieldName;

    _Fields(short thriftId, String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final int __USERID_ISSET_ID = 0;
  private static final int __AMOUNT_ISSET_ID = 1;
  private static final int __GAMEDETAILID_ISSET_ID = 2;
  private byte __isset_bitfield = 0;
  public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
  static {
    Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.T_TYPE, new org.apache.thrift.meta_data.FieldMetaData("tType", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.EnumMetaData(org.apache.thrift.protocol.TType.ENUM, ThriftTransactionType.class)));
    tmpMap.put(_Fields.USER_ID, new org.apache.thrift.meta_data.FieldMetaData("userId", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64)));
    tmpMap.put(_Fields.AMOUNT, new org.apache.thrift.meta_data.FieldMetaData("amount", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.DOUBLE)));
    tmpMap.put(_Fields.GAME_DETAIL_ID, new org.apache.thrift.meta_data.FieldMetaData("gameDetailId", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64)));
    metaDataMap = Collections.unmodifiableMap(tmpMap);
    org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(ThriftGameCreditRequestInfo.class, metaDataMap);
  }

  public ThriftGameCreditRequestInfo() {
  }

  public ThriftGameCreditRequestInfo(
    ThriftTransactionType tType,
    long userId,
    double amount,
    long gameDetailId)
  {
    this();
    this.tType = tType;
    this.userId = userId;
    setUserIdIsSet(true);
    this.amount = amount;
    setAmountIsSet(true);
    this.gameDetailId = gameDetailId;
    setGameDetailIdIsSet(true);
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public ThriftGameCreditRequestInfo(ThriftGameCreditRequestInfo other) {
    __isset_bitfield = other.__isset_bitfield;
    if (other.isSetTType()) {
      this.tType = other.tType;
    }
    this.userId = other.userId;
    this.amount = other.amount;
    this.gameDetailId = other.gameDetailId;
  }

  public ThriftGameCreditRequestInfo deepCopy() {
    return new ThriftGameCreditRequestInfo(this);
  }

  @Override
  public void clear() {
    this.tType = null;
    setUserIdIsSet(false);
    this.userId = 0;
    setAmountIsSet(false);
    this.amount = 0.0;
    setGameDetailIdIsSet(false);
    this.gameDetailId = 0;
  }

  /**
   * 
   * @see ThriftTransactionType
   */
  public ThriftTransactionType getTType() {
    return this.tType;
  }

  /**
   * 
   * @see ThriftTransactionType
   */
  public ThriftGameCreditRequestInfo setTType(ThriftTransactionType tType) {
    this.tType = tType;
    return this;
  }

  public void unsetTType() {
    this.tType = null;
  }

  /** Returns true if field tType is set (has been assigned a value) and false otherwise */
  public boolean isSetTType() {
    return this.tType != null;
  }

  public void setTTypeIsSet(boolean value) {
    if (!value) {
      this.tType = null;
    }
  }

  public long getUserId() {
    return this.userId;
  }

  public ThriftGameCreditRequestInfo setUserId(long userId) {
    this.userId = userId;
    setUserIdIsSet(true);
    return this;
  }

  public void unsetUserId() {
    __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __USERID_ISSET_ID);
  }

  /** Returns true if field userId is set (has been assigned a value) and false otherwise */
  public boolean isSetUserId() {
    return EncodingUtils.testBit(__isset_bitfield, __USERID_ISSET_ID);
  }

  public void setUserIdIsSet(boolean value) {
    __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __USERID_ISSET_ID, value);
  }

  public double getAmount() {
    return this.amount;
  }

  public ThriftGameCreditRequestInfo setAmount(double amount) {
    this.amount = amount;
    setAmountIsSet(true);
    return this;
  }

  public void unsetAmount() {
    __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __AMOUNT_ISSET_ID);
  }

  /** Returns true if field amount is set (has been assigned a value) and false otherwise */
  public boolean isSetAmount() {
    return EncodingUtils.testBit(__isset_bitfield, __AMOUNT_ISSET_ID);
  }

  public void setAmountIsSet(boolean value) {
    __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __AMOUNT_ISSET_ID, value);
  }

  public long getGameDetailId() {
    return this.gameDetailId;
  }

  public ThriftGameCreditRequestInfo setGameDetailId(long gameDetailId) {
    this.gameDetailId = gameDetailId;
    setGameDetailIdIsSet(true);
    return this;
  }

  public void unsetGameDetailId() {
    __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __GAMEDETAILID_ISSET_ID);
  }

  /** Returns true if field gameDetailId is set (has been assigned a value) and false otherwise */
  public boolean isSetGameDetailId() {
    return EncodingUtils.testBit(__isset_bitfield, __GAMEDETAILID_ISSET_ID);
  }

  public void setGameDetailIdIsSet(boolean value) {
    __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __GAMEDETAILID_ISSET_ID, value);
  }

  public void setFieldValue(_Fields field, Object value) {
    switch (field) {
    case T_TYPE:
      if (value == null) {
        unsetTType();
      } else {
        setTType((ThriftTransactionType)value);
      }
      break;

    case USER_ID:
      if (value == null) {
        unsetUserId();
      } else {
        setUserId((Long)value);
      }
      break;

    case AMOUNT:
      if (value == null) {
        unsetAmount();
      } else {
        setAmount((Double)value);
      }
      break;

    case GAME_DETAIL_ID:
      if (value == null) {
        unsetGameDetailId();
      } else {
        setGameDetailId((Long)value);
      }
      break;

    }
  }

  public Object getFieldValue(_Fields field) {
    switch (field) {
    case T_TYPE:
      return getTType();

    case USER_ID:
      return Long.valueOf(getUserId());

    case AMOUNT:
      return Double.valueOf(getAmount());

    case GAME_DETAIL_ID:
      return Long.valueOf(getGameDetailId());

    }
    throw new IllegalStateException();
  }

  /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    if (field == null) {
      throw new IllegalArgumentException();
    }

    switch (field) {
    case T_TYPE:
      return isSetTType();
    case USER_ID:
      return isSetUserId();
    case AMOUNT:
      return isSetAmount();
    case GAME_DETAIL_ID:
      return isSetGameDetailId();
    }
    throw new IllegalStateException();
  }

  @Override
  public boolean equals(Object that) {
    if (that == null)
      return false;
    if (that instanceof ThriftGameCreditRequestInfo)
      return this.equals((ThriftGameCreditRequestInfo)that);
    return false;
  }

  public boolean equals(ThriftGameCreditRequestInfo that) {
    if (that == null)
      return false;

    boolean this_present_tType = true && this.isSetTType();
    boolean that_present_tType = true && that.isSetTType();
    if (this_present_tType || that_present_tType) {
      if (!(this_present_tType && that_present_tType))
        return false;
      if (!this.tType.equals(that.tType))
        return false;
    }

    boolean this_present_userId = true;
    boolean that_present_userId = true;
    if (this_present_userId || that_present_userId) {
      if (!(this_present_userId && that_present_userId))
        return false;
      if (this.userId != that.userId)
        return false;
    }

    boolean this_present_amount = true;
    boolean that_present_amount = true;
    if (this_present_amount || that_present_amount) {
      if (!(this_present_amount && that_present_amount))
        return false;
      if (this.amount != that.amount)
        return false;
    }

    boolean this_present_gameDetailId = true;
    boolean that_present_gameDetailId = true;
    if (this_present_gameDetailId || that_present_gameDetailId) {
      if (!(this_present_gameDetailId && that_present_gameDetailId))
        return false;
      if (this.gameDetailId != that.gameDetailId)
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    List<Object> list = new ArrayList<Object>();

    boolean present_tType = true && (isSetTType());
    list.add(present_tType);
    if (present_tType)
      list.add(tType.getValue());

    boolean present_userId = true;
    list.add(present_userId);
    if (present_userId)
      list.add(userId);

    boolean present_amount = true;
    list.add(present_amount);
    if (present_amount)
      list.add(amount);

    boolean present_gameDetailId = true;
    list.add(present_gameDetailId);
    if (present_gameDetailId)
      list.add(gameDetailId);

    return list.hashCode();
  }

  @Override
  public int compareTo(ThriftGameCreditRequestInfo other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;

    lastComparison = Boolean.valueOf(isSetTType()).compareTo(other.isSetTType());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetTType()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.tType, other.tType);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetUserId()).compareTo(other.isSetUserId());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetUserId()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.userId, other.userId);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetAmount()).compareTo(other.isSetAmount());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetAmount()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.amount, other.amount);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetGameDetailId()).compareTo(other.isSetGameDetailId());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetGameDetailId()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.gameDetailId, other.gameDetailId);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  public _Fields fieldForId(int fieldId) {
    return _Fields.findByThriftId(fieldId);
  }

  public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
    schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
  }

  public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
    schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder("ThriftGameCreditRequestInfo(");
    boolean first = true;

    sb.append("tType:");
    if (this.tType == null) {
      sb.append("null");
    } else {
      sb.append(this.tType);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("userId:");
    sb.append(this.userId);
    first = false;
    if (!first) sb.append(", ");
    sb.append("amount:");
    sb.append(this.amount);
    first = false;
    if (!first) sb.append(", ");
    sb.append("gameDetailId:");
    sb.append(this.gameDetailId);
    first = false;
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws org.apache.thrift.TException {
    // check for required fields
    if (tType == null) {
      throw new org.apache.thrift.protocol.TProtocolException("Required field 'tType' was not present! Struct: " + toString());
    }
    // alas, we cannot check 'userId' because it's a primitive and you chose the non-beans generator.
    // alas, we cannot check 'amount' because it's a primitive and you chose the non-beans generator.
    // alas, we cannot check 'gameDetailId' because it's a primitive and you chose the non-beans generator.
    // check for sub-struct validity
  }

  private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
    try {
      write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
    try {
      // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
      __isset_bitfield = 0;
      read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private static class ThriftGameCreditRequestInfoStandardSchemeFactory implements SchemeFactory {
    public ThriftGameCreditRequestInfoStandardScheme getScheme() {
      return new ThriftGameCreditRequestInfoStandardScheme();
    }
  }

  private static class ThriftGameCreditRequestInfoStandardScheme extends StandardScheme<ThriftGameCreditRequestInfo> {

    public void read(org.apache.thrift.protocol.TProtocol iprot, ThriftGameCreditRequestInfo struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TField schemeField;
      iprot.readStructBegin();
      while (true)
      {
        schemeField = iprot.readFieldBegin();
        if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
          break;
        }
        switch (schemeField.id) {
          case 1: // T_TYPE
            if (schemeField.type == org.apache.thrift.protocol.TType.I32) {
              struct.tType = jayeson.vodds.service.cms.thrift.ThriftTransactionType.findByValue(iprot.readI32());
              struct.setTTypeIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 2: // USER_ID
            if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
              struct.userId = iprot.readI64();
              struct.setUserIdIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 3: // AMOUNT
            if (schemeField.type == org.apache.thrift.protocol.TType.DOUBLE) {
              struct.amount = iprot.readDouble();
              struct.setAmountIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 4: // GAME_DETAIL_ID
            if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
              struct.gameDetailId = iprot.readI64();
              struct.setGameDetailIdIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          default:
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      if (!struct.isSetUserId()) {
        throw new org.apache.thrift.protocol.TProtocolException("Required field 'userId' was not found in serialized data! Struct: " + toString());
      }
      if (!struct.isSetAmount()) {
        throw new org.apache.thrift.protocol.TProtocolException("Required field 'amount' was not found in serialized data! Struct: " + toString());
      }
      if (!struct.isSetGameDetailId()) {
        throw new org.apache.thrift.protocol.TProtocolException("Required field 'gameDetailId' was not found in serialized data! Struct: " + toString());
      }
      struct.validate();
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot, ThriftGameCreditRequestInfo struct) throws org.apache.thrift.TException {
      struct.validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (struct.tType != null) {
        oprot.writeFieldBegin(T_TYPE_FIELD_DESC);
        oprot.writeI32(struct.tType.getValue());
        oprot.writeFieldEnd();
      }
      oprot.writeFieldBegin(USER_ID_FIELD_DESC);
      oprot.writeI64(struct.userId);
      oprot.writeFieldEnd();
      oprot.writeFieldBegin(AMOUNT_FIELD_DESC);
      oprot.writeDouble(struct.amount);
      oprot.writeFieldEnd();
      oprot.writeFieldBegin(GAME_DETAIL_ID_FIELD_DESC);
      oprot.writeI64(struct.gameDetailId);
      oprot.writeFieldEnd();
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

  }

  private static class ThriftGameCreditRequestInfoTupleSchemeFactory implements SchemeFactory {
    public ThriftGameCreditRequestInfoTupleScheme getScheme() {
      return new ThriftGameCreditRequestInfoTupleScheme();
    }
  }

  private static class ThriftGameCreditRequestInfoTupleScheme extends TupleScheme<ThriftGameCreditRequestInfo> {

    @Override
    public void write(org.apache.thrift.protocol.TProtocol prot, ThriftGameCreditRequestInfo struct) throws org.apache.thrift.TException {
      TTupleProtocol oprot = (TTupleProtocol) prot;
      oprot.writeI32(struct.tType.getValue());
      oprot.writeI64(struct.userId);
      oprot.writeDouble(struct.amount);
      oprot.writeI64(struct.gameDetailId);
    }

    @Override
    public void read(org.apache.thrift.protocol.TProtocol prot, ThriftGameCreditRequestInfo struct) throws org.apache.thrift.TException {
      TTupleProtocol iprot = (TTupleProtocol) prot;
      struct.tType = jayeson.vodds.service.cms.thrift.ThriftTransactionType.findByValue(iprot.readI32());
      struct.setTTypeIsSet(true);
      struct.userId = iprot.readI64();
      struct.setUserIdIsSet(true);
      struct.amount = iprot.readDouble();
      struct.setAmountIsSet(true);
      struct.gameDetailId = iprot.readI64();
      struct.setGameDetailIdIsSet(true);
    }
  }

}

